/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.aufgabe.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class AufgabeKommentarUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String autor;

    public java.lang.String getAutor(){
      return autor;
    }
    protected final java.util.Date zeitpunkt;

    public java.util.Date getZeitpunkt(){
      return zeitpunkt;
    }

  protected final de.ivu.elect.business.aufgabe.entity.AufgabeUK aufgabeUK;

    public de.ivu.elect.business.aufgabe.entity.AufgabeUK getAufgabeUK(){
      return aufgabeUK;
    }

  public AufgabeKommentarUK(
java.lang.String autor
, java.util.Date zeitpunkt
,   de.ivu.elect.business.aufgabe.entity.AufgabeUK aufgabeUK
  ) {
    super();


      this.autor = autor;
      this.zeitpunkt = zeitpunkt;
        this.aufgabeUK = aufgabeUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((autor == null) ? 0 : autor.hashCode());
                    result = result + ((zeitpunkt == null) ? 0 : zeitpunkt.hashCode());
        
                    result = result + ((aufgabeUK == null) ? 0 : aufgabeUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            AufgabeKommentarUK other = (AufgabeKommentarUK) obj;

                if (autor == null) {
          if (other.autor != null) {
            return false;
          }
        } else if (!autor.equals(other.autor)) {
          return false;
        }
                if (zeitpunkt == null) {
          if (other.zeitpunkt != null) {
            return false;
          }
        } else if (!zeitpunkt.equals(other.zeitpunkt)) {
          return false;
        }
        
                if (aufgabeUK == null) {
          if (other.aufgabeUK != null) {
            return false;
          }
        } else if (!aufgabeUK.equals(other.aufgabeUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return AufgabeKommentarConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(aufgabeUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(AufgabeKommentarConstants.MESSAGE_KEY_ENTITY_EINZAHL, AufgabeKommentarConstants.MESSAGE_KEY_AUTOR_EINZAHL, autor));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(AufgabeKommentarConstants.MESSAGE_KEY_ENTITY_EINZAHL, AufgabeKommentarConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, zeitpunkt));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "AufgabeKommentarUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"autor="+autor
                            +", "                +"zeitpunkt="+zeitpunkt
                                        +", "                +"aufgabeUK="+aufgabeUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(autor);
         list.add(zeitpunkt);
     return list;
   }

            public static <E extends AufgabeKommentar> java.util.Map<AufgabeKommentarUK, E> mappeAufgabeKommentarNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(AufgabeKommentar::getAufgabeKommentarUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<AufgabeKommentar, AufgabeKommentarUK> getAufgabeKommentarToUKFunction() {
                return AufgabeKommentar::getAufgabeKommentarUK;
                }

}
